#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#ifndef _GETPASSINFO_H_
#define _GETPASSINFO_H_

#define BUFFER_SIZE 128
#define DEBUG_GPI 0

#define GPREDICT_DATA_PATH (const char*) "/data/gpredict_next_pass.txt"
#define HEADER_SIZE 3

typedef struct gdate{
    char year[3];
    char month[3];
    char day[3];
}gdate_t;

typedef struct gtime{
    char hour[3];
    char minute[3];
    char second[3];
}gtime_t;

typedef struct g_data{
    gdate_t gdate;
    gtime_t gtime;
    float Az;
    float El;
}g_data_t;


uint32_t    readGpredictFile(void);
uint32_t    getFileSize(FILE * file);
void        organizeGpredictData(g_data_t gpredictStruct[], uint32_t datasize);
void        storeGpredictData(g_data_t gpredictData[], uint32_t datasize, FILE * file);
void        set_gdate(g_data_t gpredictData[], uint32_t datasize, uint32_t index, char *token);
void        set_gtime(g_data_t gpredictData[], uint32_t datasize, uint32_t index, char *token);

int         string2tokens(char string[], char* tokenArray[], const int tokenArraySize, const char* delim );

void        printgdata(g_data_t gpredictData[], uint32_t datasize);

#endif
