#include "queue.h"

queue_t* queueInit(uint32_t capacity){
    queue_t* queue = (struct queue_t*) malloc(sizeof(queue_t));
    queue->capacity = capacity;
    queue->front = 0;
    queue->size = 0;
    queue->rear = capacity - 1;

    queue->array = malloc((queue->capacity) * sizeof(int));

    return(queue);
}

void enqueue(queue_t * queue, int data){

    if(isQFull(queue)){
        perror("Error: Queue is full");
        return;
    }

    queue->rear = (queue->rear + 1) % (queue->capacity);
    queue->array[queue->rear] = data;
    queue->size+=1;
}

int dequeue(queue_t * queue){
    if(isQEmpty(queue)){
        perror("Error: Queue is empty");
        exit(1);
    }

    int data = queue->array[queue->front];
    queue->front = (queue->front + 1) % (queue->capacity);
    queue->size-=1;
    return(data);
}

uint8_t isQEmpty(queue_t * queue){
    return(queue->size == 0);
}

uint8_t isQFull(queue_t * queue){
    return(queue->size == queue->capacity);
}

char printQueue(queue_t * queue){

    queue_t* queueTemp = queueInit(queue->size);
    if(isQEmpty(queue)) return(-1);

    int buffer[queue->size];

    printf("Queue:");

    for(uint8_t i = 0; !isQEmpty(queue); i++){
        buffer[i] = dequeue(queue);
        printf("%d ", buffer[i]);
        enqueue(queueTemp, buffer[i]);
    }
    
    printf("\n");

    //put back into queue
     for(uint8_t i = 0; !isQEmpty(queueTemp); i++){
        enqueue(queue, dequeue(queueTemp));
    }
    return(1);
}