/*
 * frames.h
 *  description: header for main frame functions source code
 *  Created on: Feb. 16, 2022
 *      Author: Brett Robertson
 */

#ifndef FRAMES_H_
#define FRAMES_H_



#define PACKET_IN (const char*) "\input-packet.bin"
#define PACKET_OUT (const char*) "\output-packet.bin"
#define FRAME_IN (const char*) "\input-frame.bin"
#define FRAME_OUT (const char*) "\output-frame.bin"  //define file paths

//int opselect, psf_default=0, pscn_default = 0, aid_default=0; //Define (de)construction variables
//unsigned char fvn = 0x02, aid = 0x0e, psf = 0x02, pscn[4] = {0xf2,0x34,0xff,0xff}; //pscn is set randomly here since this will have to be stored elsewhere (cannot be initialised on each boot for CoM)
//unsigned char testkey1[5]={0xdf, 0x45, 0x99, 0x69, 0x83};
//unsigned char testkey[5]={0xde, 0x45, 0x99, 0x69, 0x83};


void fill_packet(unsigned char *packet, int length);
void increment_pscn();
unsigned int do_crc32(unsigned char *msg, unsigned int length);
void do_hmac_hash(unsigned char *msg, unsigned char *hashout, unsigned int len);
void do_hmac_encrypt(unsigned char *msg, unsigned char *hmac, unsigned char *key, unsigned int len);
unsigned int frame_decon(unsigned char *frame, unsigned char *packet, unsigned int len);
unsigned int frame_con(unsigned char *packet, unsigned char *frame, unsigned int len);
unsigned int dll_process(const char* src, const char* dest, int op/*, unsigned char psf, unsigned char aid, unsigned char fvn*/, unsigned int length);  //commented out inputs are to be added later

void gndconcat(unsigned char *packet, uint32_t len, unsigned char psf, int pscn);


#endif /* FRAMES_H_ */





