/*
 * frametest.c
 * desc: test function for frame operation functions.
 *  Created on: Feb. 16, 2022
 *      Author: Brett Robertson
 */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<stdint.h>
#include"getPacket.h"
#include"sha256.h"
#include"frames.h"
#include"aes.h"

int main(){

	uint32_t len;
	WORD key_schedule = 0;
	const BYTE aeskey[32]={26};
	const BYTE aes_iv[AES_BLOCK_SIZE]={0};

	aes_key_setup(aeskey, &key_schedule, 128); //setup aeskey, just incase

	unsigned int status_out;
		setvbuf(stdout, NULL, _IONBF, 0);
		setvbuf(stderr, NULL, _IONBF, 0);

		int pick, choice;




		unsigned char* testpacket[142], testframe[142+18];

//len = sizeData(TEST_BIN);
//
//printf("len is %u\n", len);
//
//storeData(testpacket, len, TEST_BIN);
//printf("testpacket2 is %c\n", testpacket[2]);
//appendData(testpacket, len, MEMCAT_STORE);
//printf("did append maybe\n");





printf("input '0' for construction test, input '1' for de-construction test:\n");
scanf("%d", &pick);




switch (pick){
case 0:
	len = sizeData(PACKET_IN);
	//		printf("len = %d\n", len);
    status_out = dll_process(PACKET_IN, FRAME_OUT, 0, len);  //produces frame from input-packet and stores in output-frame, known packet length
    printf("Frame construction complete.\n");


    printf("Would you like to encrypt this frame? (0=yes / 1=no)\n");
    scanf("%d", &choice);

		switch(choice){
            case 0:
            	len = sizeData(FRAME_OUT);
        	    storeData(testframe, len, FRAME_OUT);

        	    aes_encrypt_ctr(testframe, len, testframe, &key_schedule, 128, aes_iv);

        	    writeData(testframe, len, FRAME_OUT);

        	    printf("New input frame saved.\n");
        	    break;
            case 1:
            	printf("Alright then.\n");
            	break;
            default:
            	printf("Invalid input.\n");
            }


    printf("Copy the output frame to the input frame for a frame de-construction test? (0=yes / 1=no)\n");
        scanf("%d", &choice);

        switch(choice){
        case 0:
        	len = sizeData(FRAME_OUT);
    	    storeData(testframe, len, FRAME_OUT);
    	    writeData(testframe, len, FRAME_IN);
    	    printf("New input frame saved.\n");
    	    break;
        case 1:
        	printf("Alright then.\n");
        	break;
        default:
        	printf("Invalid input.\n");
        }


    break;

    case 1:
    	printf("Is the target frame encrypted? (0=yes / 1=no)\n");
    	scanf("%d", &choice);

    	if (choice == 0){
        	len = sizeData(FRAME_IN);
    	    storeData(testframe, len, FRAME_IN);

    	    aes_decrypt_ctr(testframe, len, testframe, &key_schedule, 128, aes_iv);

    	    writeData(testframe, len, FRAME_IN);

    	}

    	len = sizeData(FRAME_IN);
    	status_out = dll_process(FRAME_IN, PACKET_OUT, 1, len);
    	printf("Frame de-construction complete.\n");
    	break;
    default:
    	printf("Invalid input.\n");
}

printf("dll_process returned: %u\n", status_out);
printf("Test terminated.\n");

}
